Index: /trunk/include/FlairCore/io_data.h
===================================================================
--- /trunk/include/FlairCore/io_data.h	(revision 75)
+++ /trunk/include/FlairCore/io_data.h	(revision 76)
@@ -176,4 +176,26 @@
 
   virtual DataType const &GetDataType() const = 0;
+  
+  /*!
+  * \brief Raw write datas
+  *
+  * Copy the source to the internal datas. Source must be of the corresponding size.
+  *
+  * \param src source buffer
+  */
+  virtual void RawWrite(char *src)  {};//todo put pure virtual
+  
+  /*!
+  * \brief Raw read datas
+  *
+  * This method is automatically called by IODevice::ProcessUpdate to log
+  * io_data datas. \n
+  * This method must be reimplemented, in order to copy the datas to the logs.
+  * Copy the internal datas to destination. Destination must be of the corresponding size.
+  *
+  * \param dst destination buffer
+  */
+  virtual void RawRead(char *dst) const = 0;
+
 
 protected:
@@ -208,16 +230,4 @@
 
 private:
-  /*!
-  * \brief Copy datas
-  *
-  * This method is automatically called by IODevice::ProcessUpdate to log
-  *io_data datas. \n
-  * This method must be reimplemented, in order to copy the datas to the logs.
-  * Copied datas must be of size io_data::Size.
-  *
-  * \param dst destination buffer
-  */
-  virtual void CopyDatas(char *dst) const = 0;
-
   io_data_impl *pimpl_;
 };
Index: /trunk/include/FlairFilter/Pid.h
===================================================================
--- /trunk/include/FlairFilter/Pid.h	(revision 75)
+++ /trunk/include/FlairFilter/Pid.h	(revision 76)
@@ -58,4 +58,12 @@
   */
   void Reset(void);
+  
+   /*!
+  * \brief Get intergral part
+  *
+  * \return current integral part
+  */
+  float GetIntegral(void) const;
+
 
   /*!
Index: /trunk/include/FlairSensorActuator/TargetController.h
===================================================================
--- /trunk/include/FlairSensorActuator/TargetController.h	(revision 75)
+++ /trunk/include/FlairSensorActuator/TargetController.h	(revision 76)
@@ -82,5 +82,5 @@
   // axis stuff
   unsigned int axisNumber;
-  core::Matrix *axis = NULL;
+  core::Matrix *axis = nullptr;
   virtual void AcquireAxisData(core::Matrix &axis) = 0; // responsible for
                                                           // getting the axis
@@ -90,5 +90,5 @@
   // button stuff
   unsigned int buttonNumber;
-  core::Matrix *button = NULL;
+  core::Matrix *button = nullptr;
   virtual void AcquireButtonData(core::Matrix &button) = 0; // responsible for
                                                               // getting the
Index: /trunk/include/FlairSensorActuator/TargetEthController.h
===================================================================
--- /trunk/include/FlairSensorActuator/TargetEthController.h	(revision 75)
+++ /trunk/include/FlairSensorActuator/TargetEthController.h	(revision 76)
@@ -77,8 +77,8 @@
   core::TcpSocket *listeningSocket;
   int listeningPort;
-  core::TcpSocket *controlSocket = NULL;
+  core::TcpSocket *controlSocket = nullptr;
   core::UdpSocket *dataSocket;
-  std::string *axisName = NULL;
-  std::string *buttonName = NULL;
+  std::string *axisName = nullptr;
+  std::string *buttonName = nullptr;
   size_t dataFrameSize;
   char *dataFrameBuffer;
Index: /trunk/include/FlairVisionFilter/OpticalFlowData.h
===================================================================
--- /trunk/include/FlairVisionFilter/OpticalFlowData.h	(revision 75)
+++ /trunk/include/FlairVisionFilter/OpticalFlowData.h	(revision 76)
@@ -129,4 +129,14 @@
 
         OpticalFlowData::Type const &GetDataType() const {return dataType;}
+        
+        /*!
+        * \brief Raw read datas
+        *
+        * Reimplemented from io_data. \n
+        * See io_data::RawRead.
+        *
+        * \param dst destination buffer
+        */
+        void RawRead(char *dst) const;
 
     private:
@@ -137,5 +147,4 @@
         char *found_features;
         uint32_t *features_error;
-        void CopyDatas(char* dst) const;
         Type dataType;
     };
